#include <bits/stdc++.h>
using namespace std;

int main(void) {
    int n, m, b, r;
    scanf("%d%d%d%d", &n, &m, &b, &r);
    if (m < n) {
        printf("impossible\n");
        return 0;
    }
    vector<vector<int>> totplay(n, vector<int>(m, 0));
    vector<vector<int>> firstplay(n, vector<int>(m, b+1));
    vector<pair<int, int>> curtoy(n, make_pair(-1, 0));
    for (int i = 0; i < r; ++i) {
        int s, k, t;
        scanf("%d%d%d", &s, &k, &t);
        --k; --t;
        if (t != -1) firstplay[k][t] = min(firstplay[k][t], s);
        auto p = curtoy[k];
        if (p.first != -1) totplay[k][p.first] += s - p.second;
        curtoy[k] = make_pair(t, s);
    }
    for (int i = 0; i < n; ++i)
        if (curtoy[i].first != -1)
            totplay[i][curtoy[i].first] += b - curtoy[i].second;

    vector<int> toy(m);
    iota(toy.begin(), toy.end(), 0);
    random_shuffle(toy.begin(), toy.end());
    toy.resize(n);
    while (true) {
        bool ok = true;
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j) {
                if (i == j) continue;
                if (totplay[i][toy[j]] < totplay[j][toy[j]] &&
                    firstplay[i][toy[i]] > firstplay[i][toy[j]]) {
                    ok = false;
                    swap(toy[i], toy[j]);
                }
            }
        if (ok) break;
    }
    for (int i = 0; i < n; ++i)
        printf("%d\n", toy[i]+1);
}
